#include <define.h>

Motor_move_data left_motor;
Motor_move_data right_motor;

long double left_motor_angle=0;
long double left_motor_angle_last=0;
bool left_motor_update = 0;

long double right_motor_angle=0;
long double right_motor_angle_last=0;
bool right_motor_update = 0;

Enc_data enc_data;
unsigned long long serial_flush_timer=0;

Claw_move_data claw;
Claw_move_data gimble;
Claw_move_data magasine;

void setup() {
  Serial1.begin(115200, SERIAL_8N1, MOTOTRS_DRIVER_RX, MOTOTRS_DRIVER_TX);
  Serial2.begin(115200, SERIAL_8N1, CLAW_DRIVER_RX, CLAW_DRIVER_TX);
  Serial.begin(115200);
     
  left_motor.motor_number = 0;
  right_motor.motor_number = 1;
  claw.motor_number =  0;
  gimble.motor_number = 1;
  magasine.motor_number = 2;
  delay(5000);

  right_motor.speed = 370;
  left_motor.speed = 400;
  Serial1.write((byte*)&left_motor, sizeof(Motor_move_data));
  Serial1.write((byte*)&right_motor, sizeof(Motor_move_data));
  delay(3100);
  right_motor.speed = 0;
  left_motor.speed = 0;
  Serial1.write((byte*)&left_motor, sizeof(Motor_move_data));
  Serial1.write((byte*)&right_motor, sizeof(Motor_move_data));

  
  claw.angle = 55;
  Serial2.write((byte*)&claw, sizeof(Claw_move_data));

  delay(1000);

  gimble.angle = 90;
  Serial2.write((byte*)&gimble, sizeof(Claw_move_data));

  delay(1000);

  right_motor.speed = -630;
  left_motor.speed = -700;
  Serial1.write((byte*)&left_motor, sizeof(Motor_move_data));
  Serial1.write((byte*)&right_motor, sizeof(Motor_move_data));
  delay(1000);
  right_motor.speed = 0;
  left_motor.speed = 0;
  Serial1.write((byte*)&left_motor, sizeof(Motor_move_data));
  Serial1.write((byte*)&right_motor, sizeof(Motor_move_data));
}

void loop() {
  /*right_motor.speed = 700;
  left_motor.speed = 700;
  //Serial1.write((byte*)&left_motor, sizeof(Motor_move_data));
  //Serial1.write((byte*)&right_motor, sizeof(Motor_move_data));
  gimble.angle = 70;
  claw.angle = 30;
  Serial2.write((byte*)&gimble, sizeof(Claw_move_data));
  Serial2.write((byte*)&claw, sizeof(Claw_move_data));

  delay(1000);

  //right_motor.speed = 0;
 //left_motor.speed = 0;
  //Serial1.write((byte*)&left_motor, sizeof(Motor_move_data));
  //Serial1.write((byte*)&right_motor, sizeof(Motor_move_data));

  //delay(1000);
  
  if(Serial1.available() >= sizeof(enc_data)){
    Serial.println(Serial1.available());
    serial_flush_timer = millis();
    Serial1.readBytes((byte*)&enc_data, 6);
    Serial.print("\n");
    Serial.println(Serial1.available());
    Serial.print(enc_data.motor_number);
    Serial.print(" ");
    Serial.println(enc_data.angle);
    if(enc_data.motor_number == 0){
      left_motor_angle = enc_data.angle;
      left_motor_update = 1;
    }
    if(enc_data.motor_number == 1){
      right_motor_angle = enc_data.angle;
      right_motor_update = 1;
    }
  }

  if (Serial1.available() == 0){
    serial_flush_timer = millis();
  }

  if (millis() - serial_flush_timer > 10){
    while(Serial1.available() > 0) {
      char t = Serial1.read();
    }
  }

  if(left_motor_update && right_motor_update){
    Serial.print(double(left_motor_angle));
    Serial.print(" ");
    Serial.println(double(right_motor_angle));
    left_motor_update = 0;
    right_motor_update = 0;
  }*/
}